/**
 * Copyright (c) 2012 EBM WebSourcing, 2012-2017 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.admin.junit;

import org.ow2.petals.admin.api.artifact.ServiceAssembly;
import org.ow2.petals.admin.api.artifact.lifecycle.ServiceAssemblyLifecycle;
import org.ow2.petals.admin.topology.Container;

/**
 * 
 * @author "Mathieu CARROLLE - EBM WebSourcing"
 */
public class ServiceAssemblyLifecycleMock extends AbstractArtifactStateLifecycleMock<ServiceAssembly>
        implements ServiceAssemblyLifecycle {

    public ServiceAssemblyLifecycleMock(final ServiceAssembly sa, final Container container) {
        super(sa, container);
    }

    @Override
    public ServiceAssembly getServiceAssembly() {
        return this.artifact;
    }

    @Override
    protected ServiceAssembly findArtefactInContainer() {
        for (ServiceAssembly existingSA : this.container.getServiceAssemblies()) {
            // the real implementation only use getName() from the current artifact
            if (existingSA.getName().equals(this.getServiceAssembly().getName())) {
                return existingSA;
            }
        }
        return null;
    }

    @Override
    protected void registerArtefactInContainerForDeploy(ServiceAssembly artifact) {
        this.container.addServiceAssembly(artifact);
    }

    @Override
    protected void removeArtefactInContainerForUndeploy(ServiceAssembly artifact) {
        this.container.removeServiceAssembly(artifact);
    }
}
